package com.ruoyi.frequency.vote.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.controller.resp.VoteDetailResp;
import com.ruoyi.controller.resp.VotePageResp;
import com.ruoyi.frequency.vote.entity.Vote;
import com.ruoyi.frequency.vote.model.result.VoteCount;
import com.ruoyi.vo.UserVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 投票活动Mapper接口
 *
 * @author liwenlong
 * @date 2023-10-12
 */
public interface VoteMapper  extends BaseMapper<Vote>
{
    /**
     * 查询投票活动
     *
     * @param id 投票活动主键
     * @return 投票活动
     */
    public Vote selectVoteById(Long id);

    /**
     * 查询投票活动列表
     *
     * @param vote 投票活动
     * @return 投票活动集合
     */
    public List<Vote> selectVoteList(Vote vote);

    /**
     * 新增投票活动
     *
     * @param vote 投票活动
     * @return 结果
     */
    public int insertVote(Vote vote);

    /**
     * 修改投票活动
     *
     * @param vote 投票活动
     * @return 结果
     */
    public int updateVote(Vote vote);

    /**
     * 删除投票活动
     *
     * @param id 投票活动主键
     * @return 结果
     */
    public int deleteVoteById(Long id);

    /**
     * 批量删除投票活动
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteVoteByIds(Long[] ids);

    Page<VotePageResp> votePage(@Param("page") Page<Object> objectPage, @Param("userVo") UserVo userVo,@Param("isSelf") boolean isSelf);

    VoteDetailResp voteDetail(@Param("voteId") Long voteId,@Param("userVo")  UserVo userVo);

    VoteCount statistics( @Param("list") List<Long> voteIdList );
}
